/* rygel-xbmc4xbox-hacks.c generated by valac 0.44.9, the Vala compiler
 * generated from rygel-xbmc4xbox-hacks.vala, do not modify */

/*
 * Copyright (C) 2017 Samuel CUELLA
 *
 * Author: Samuel CUELLA <samuel.cuella@supinfo.com>
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <libsoup/soup.h>

#define RYGEL_TYPE_CLIENT_HACKS (rygel_client_hacks_get_type ())
#define RYGEL_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacks))
#define RYGEL_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))
#define RYGEL_IS_CLIENT_HACKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_IS_CLIENT_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CLIENT_HACKS))
#define RYGEL_CLIENT_HACKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CLIENT_HACKS, RygelClientHacksClass))

typedef struct _RygelClientHacks RygelClientHacks;
typedef struct _RygelClientHacksClass RygelClientHacksClass;
typedef struct _RygelClientHacksPrivate RygelClientHacksPrivate;

#define RYGEL_TYPE_MEDIA_QUERY_ACTION (rygel_media_query_action_get_type ())
#define RYGEL_MEDIA_QUERY_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_MEDIA_QUERY_ACTION, RygelMediaQueryAction))
#define RYGEL_MEDIA_QUERY_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_MEDIA_QUERY_ACTION, RygelMediaQueryActionClass))
#define RYGEL_IS_MEDIA_QUERY_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_MEDIA_QUERY_ACTION))
#define RYGEL_IS_MEDIA_QUERY_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_MEDIA_QUERY_ACTION))
#define RYGEL_MEDIA_QUERY_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_MEDIA_QUERY_ACTION, RygelMediaQueryActionClass))

typedef struct _RygelMediaQueryAction RygelMediaQueryAction;
typedef struct _RygelMediaQueryActionClass RygelMediaQueryActionClass;

#define RYGEL_TYPE_MEDIA_OBJECT (rygel_media_object_get_type ())
#define RYGEL_MEDIA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_MEDIA_OBJECT, RygelMediaObject))
#define RYGEL_MEDIA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_MEDIA_OBJECT, RygelMediaObjectClass))
#define RYGEL_IS_MEDIA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_MEDIA_OBJECT))
#define RYGEL_IS_MEDIA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_MEDIA_OBJECT))
#define RYGEL_MEDIA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_MEDIA_OBJECT, RygelMediaObjectClass))

typedef struct _RygelMediaObject RygelMediaObject;
typedef struct _RygelMediaObjectClass RygelMediaObjectClass;

#define RYGEL_TYPE_HTTP_REQUEST (rygel_http_request_get_type ())
#define RYGEL_HTTP_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_HTTP_REQUEST, RygelHTTPRequest))
#define RYGEL_HTTP_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_HTTP_REQUEST, RygelHTTPRequestClass))
#define RYGEL_IS_HTTP_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_HTTP_REQUEST))
#define RYGEL_IS_HTTP_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_HTTP_REQUEST))
#define RYGEL_HTTP_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_HTTP_REQUEST, RygelHTTPRequestClass))

typedef struct _RygelHTTPRequest RygelHTTPRequest;
typedef struct _RygelHTTPRequestClass RygelHTTPRequestClass;

#define RYGEL_TYPE_SEARCHABLE_CONTAINER (rygel_searchable_container_get_type ())
#define RYGEL_SEARCHABLE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_SEARCHABLE_CONTAINER, RygelSearchableContainer))
#define RYGEL_IS_SEARCHABLE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_SEARCHABLE_CONTAINER))
#define RYGEL_SEARCHABLE_CONTAINER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), RYGEL_TYPE_SEARCHABLE_CONTAINER, RygelSearchableContainerIface))

typedef struct _RygelSearchableContainer RygelSearchableContainer;
typedef struct _RygelSearchableContainerIface RygelSearchableContainerIface;

#define RYGEL_TYPE_MEDIA_CONTAINER (rygel_media_container_get_type ())
#define RYGEL_MEDIA_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_MEDIA_CONTAINER, RygelMediaContainer))
#define RYGEL_MEDIA_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_MEDIA_CONTAINER, RygelMediaContainerClass))
#define RYGEL_IS_MEDIA_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_MEDIA_CONTAINER))
#define RYGEL_IS_MEDIA_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_MEDIA_CONTAINER))
#define RYGEL_MEDIA_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_MEDIA_CONTAINER, RygelMediaContainerClass))

typedef struct _RygelMediaContainer RygelMediaContainer;
typedef struct _RygelMediaContainerClass RygelMediaContainerClass;

#define RYGEL_TYPE_SEARCH_EXPRESSION (rygel_search_expression_get_type ())
#define RYGEL_SEARCH_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_SEARCH_EXPRESSION, RygelSearchExpression))
#define RYGEL_SEARCH_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_SEARCH_EXPRESSION, RygelSearchExpressionClass))
#define RYGEL_IS_SEARCH_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_SEARCH_EXPRESSION))
#define RYGEL_IS_SEARCH_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_SEARCH_EXPRESSION))
#define RYGEL_SEARCH_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_SEARCH_EXPRESSION, RygelSearchExpressionClass))

typedef struct _RygelSearchExpression RygelSearchExpression;
typedef struct _RygelSearchExpressionClass RygelSearchExpressionClass;

#define RYGEL_TYPE_MEDIA_OBJECTS (rygel_media_objects_get_type ())
#define RYGEL_MEDIA_OBJECTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_MEDIA_OBJECTS, RygelMediaObjects))
#define RYGEL_MEDIA_OBJECTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_MEDIA_OBJECTS, RygelMediaObjectsClass))
#define RYGEL_IS_MEDIA_OBJECTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_MEDIA_OBJECTS))
#define RYGEL_IS_MEDIA_OBJECTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_MEDIA_OBJECTS))
#define RYGEL_MEDIA_OBJECTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_MEDIA_OBJECTS, RygelMediaObjectsClass))

typedef struct _RygelMediaObjects RygelMediaObjects;
typedef struct _RygelMediaObjectsClass RygelMediaObjectsClass;

#define RYGEL_TYPE_XBMC_HACKS (rygel_xbmc_hacks_get_type ())
#define RYGEL_XBMC_HACKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_XBMC_HACKS, RygelXBMCHacks))
#define RYGEL_XBMC_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_XBMC_HACKS, RygelXBMCHacksClass))
#define RYGEL_IS_XBMC_HACKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_XBMC_HACKS))
#define RYGEL_IS_XBMC_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_XBMC_HACKS))
#define RYGEL_XBMC_HACKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_XBMC_HACKS, RygelXBMCHacksClass))

typedef struct _RygelXBMCHacks RygelXBMCHacks;
typedef struct _RygelXBMCHacksClass RygelXBMCHacksClass;
typedef struct _RygelXBMCHacksPrivate RygelXBMCHacksPrivate;

#define RYGEL_TYPE_XBM_C4_XBOX_HACKS (rygel_xbm_c4_xbox_hacks_get_type ())
#define RYGEL_XBM_C4_XBOX_HACKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_XBM_C4_XBOX_HACKS, RygelXBMC4XBoxHacks))
#define RYGEL_XBM_C4_XBOX_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_XBM_C4_XBOX_HACKS, RygelXBMC4XBoxHacksClass))
#define RYGEL_IS_XBM_C4_XBOX_HACKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_XBM_C4_XBOX_HACKS))
#define RYGEL_IS_XBM_C4_XBOX_HACKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_XBM_C4_XBOX_HACKS))
#define RYGEL_XBM_C4_XBOX_HACKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_XBM_C4_XBOX_HACKS, RygelXBMC4XBoxHacksClass))

typedef struct _RygelXBMC4XBoxHacks RygelXBMC4XBoxHacks;
typedef struct _RygelXBMC4XBoxHacksClass RygelXBMC4XBoxHacksClass;
typedef struct _RygelXBMC4XBoxHacksPrivate RygelXBMC4XBoxHacksPrivate;
enum  {
	RYGEL_XBM_C4_XBOX_HACKS_0_PROPERTY,
	RYGEL_XBM_C4_XBOX_HACKS_NUM_PROPERTIES
};
static GParamSpec* rygel_xbm_c4_xbox_hacks_properties[RYGEL_XBM_C4_XBOX_HACKS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define RYGEL_TYPE_MEDIA_RESOURCE (rygel_media_resource_get_type ())
#define RYGEL_MEDIA_RESOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_MEDIA_RESOURCE, RygelMediaResource))
#define RYGEL_MEDIA_RESOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_MEDIA_RESOURCE, RygelMediaResourceClass))
#define RYGEL_IS_MEDIA_RESOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_MEDIA_RESOURCE))
#define RYGEL_IS_MEDIA_RESOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_MEDIA_RESOURCE))
#define RYGEL_MEDIA_RESOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_MEDIA_RESOURCE, RygelMediaResourceClass))

typedef struct _RygelMediaResource RygelMediaResource;
typedef struct _RygelMediaResourceClass RygelMediaResourceClass;

struct _RygelSearchableContainerIface {
	GTypeInterface parent_iface;
	void (*search) (RygelSearchableContainer* self, RygelSearchExpression* expression, guint offset, guint max_count, const gchar* sort_criteria, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	RygelMediaObjects* (*search_finish) (RygelSearchableContainer* self, GAsyncResult* _res_, guint* total_matches, GError** error);
	GeeArrayList* (*get_search_classes) (RygelSearchableContainer* self);
	void (*set_search_classes) (RygelSearchableContainer* self, GeeArrayList* value);
};

struct _RygelClientHacks {
	GObject parent_instance;
	RygelClientHacksPrivate * priv;
	GRegex* agent_regex;
};

struct _RygelClientHacksClass {
	GObjectClass parent_class;
	void (*translate_container_id) (RygelClientHacks* self, RygelMediaQueryAction* action, gchar* * container_id);
	void (*apply) (RygelClientHacks* self, RygelMediaObject* object);
	void (*filter_sort_criteria) (RygelClientHacks* self, gchar* * sort_criteria);
	gboolean (*force_seek) (RygelClientHacks* self);
	void (*modify_headers) (RygelClientHacks* self, RygelHTTPRequest* request);
	void (*search) (RygelClientHacks* self, RygelSearchableContainer* container, RygelSearchExpression* expression, guint offset, guint max_count, const gchar* sort_criteria, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	RygelMediaObjects* (*search_finish) (RygelClientHacks* self, GAsyncResult* _res_, guint* total_matches, GError** error);
};

struct _RygelXBMCHacks {
	RygelClientHacks parent_instance;
	RygelXBMCHacksPrivate * priv;
};

struct _RygelXBMCHacksClass {
	RygelClientHacksClass parent_class;
};

struct _RygelXBMC4XBoxHacks {
	RygelXBMCHacks parent_instance;
	RygelXBMC4XBoxHacksPrivate * priv;
};

struct _RygelXBMC4XBoxHacksClass {
	RygelXBMCHacksClass parent_class;
};

typedef enum  {
	RYGEL_CLIENT_HACKS_ERROR_NA
} RygelClientHacksError;
#define RYGEL_CLIENT_HACKS_ERROR rygel_client_hacks_error_quark ()

static gpointer rygel_xbm_c4_xbox_hacks_parent_class = NULL;

GType rygel_client_hacks_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelClientHacks, g_object_unref)
GType rygel_media_query_action_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaQueryAction, g_object_unref)
GType rygel_media_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaObject, g_object_unref)
GType rygel_http_request_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelHTTPRequest, g_object_unref)
GType rygel_media_container_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaContainer, g_object_unref)
gpointer rygel_search_expression_ref (gpointer instance);
void rygel_search_expression_unref (gpointer instance);
GParamSpec* rygel_param_spec_search_expression (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void rygel_value_set_search_expression (GValue* value,
                                        gpointer v_object);
void rygel_value_take_search_expression (GValue* value,
                                         gpointer v_object);
gpointer rygel_value_get_search_expression (const GValue* value);
GType rygel_search_expression_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelSearchExpression, rygel_search_expression_unref)
GType rygel_media_objects_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaObjects, g_object_unref)
GType rygel_searchable_container_get_type (void) G_GNUC_CONST;
GType rygel_xbmc_hacks_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelXBMCHacks, g_object_unref)
GType rygel_xbm_c4_xbox_hacks_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelXBMC4XBoxHacks, g_object_unref)
#define RYGEL_XBM_C4_XBOX_HACKS_AGENT "(.*XBMC.*Xbox.*)|(Platinum/0.5.3.0)"
GQuark rygel_client_hacks_error_quark (void);
RygelXBMC4XBoxHacks* rygel_xbm_c4_xbox_hacks_new (SoupMessage* message,
                                                  GError** error);
RygelXBMC4XBoxHacks* rygel_xbm_c4_xbox_hacks_construct (GType object_type,
                                                        SoupMessage* message,
                                                        GError** error);
RygelXBMCHacks* rygel_xbmc_hacks_new (SoupMessage* message,
                                      const gchar* agent,
                                      GError** error);
RygelXBMCHacks* rygel_xbmc_hacks_construct (GType object_type,
                                            SoupMessage* message,
                                            const gchar* agent,
                                            GError** error);
static void rygel_xbm_c4_xbox_hacks_real_apply (RygelClientHacks* base,
                                         RygelMediaObject* object);
void rygel_client_hacks_apply (RygelClientHacks* self,
                               RygelMediaObject* object);
GType rygel_media_resource_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelMediaResource, g_object_unref)
GeeList* rygel_media_object_get_resource_list (RygelMediaObject* self);
const gchar* rygel_media_object_get_title (RygelMediaObject* self);
gint rygel_media_resource_get_width (RygelMediaResource* self);
gint rygel_media_resource_get_height (RygelMediaResource* self);
const gchar* rygel_media_resource_get_extension (RygelMediaResource* self);
const gchar* rygel_media_resource_get_dlna_profile (RygelMediaResource* self);

RygelXBMC4XBoxHacks*
rygel_xbm_c4_xbox_hacks_construct (GType object_type,
                                   SoupMessage* message,
                                   GError** error)
{
	RygelXBMC4XBoxHacks * self = NULL;
	GError* _inner_error0_ = NULL;
	self = (RygelXBMC4XBoxHacks*) rygel_xbmc_hacks_construct (object_type, message, RYGEL_XBM_C4_XBOX_HACKS_AGENT, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == RYGEL_CLIENT_HACKS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	return self;
}

RygelXBMC4XBoxHacks*
rygel_xbm_c4_xbox_hacks_new (SoupMessage* message,
                             GError** error)
{
	return rygel_xbm_c4_xbox_hacks_construct (RYGEL_TYPE_XBM_C4_XBOX_HACKS, message, error);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
rygel_xbm_c4_xbox_hacks_real_apply (RygelClientHacks* base,
                                    RygelMediaObject* object)
{
	RygelXBMC4XBoxHacks * self;
	GeeList* resources = NULL;
	GeeList* _tmp0_;
	RygelMediaResource* primary = NULL;
	GeeList* _tmp1_;
	gpointer _tmp2_;
	RygelMediaResource* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	RygelMediaResource* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	RygelMediaResource* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	RygelMediaResource* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	RygelMediaResource* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	RygelMediaResource* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	RygelMediaResource* right_one = NULL;
	RygelMediaResource* _tmp37_;
	self = (RygelXBMC4XBoxHacks*) base;
	g_return_if_fail (object != NULL);
	RYGEL_CLIENT_HACKS_CLASS (rygel_xbm_c4_xbox_hacks_parent_class)->apply ((RygelClientHacks*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_XBMC_HACKS, RygelXBMCHacks), object);
	_tmp0_ = rygel_media_object_get_resource_list (object);
	resources = _tmp0_;
	_tmp1_ = resources;
	_tmp2_ = gee_list_first (_tmp1_);
	primary = (RygelMediaResource*) _tmp2_;
	_tmp3_ = primary;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (primary);
		_g_object_unref0 (resources);
		return;
	}
	_tmp4_ = rygel_media_object_get_title (object);
	_tmp5_ = _tmp4_;
	_tmp6_ = primary;
	_tmp7_ = rygel_media_resource_get_width (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = primary;
	_tmp10_ = rygel_media_resource_get_height (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = primary;
	_tmp13_ = rygel_media_resource_get_extension (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = primary;
	_tmp16_ = rygel_media_resource_get_dlna_profile (_tmp15_);
	_tmp17_ = _tmp16_;
	g_debug ("rygel-xbmc4xbox-hacks.vala:46: %s primary resource is %dx%d, %s. DNLA " \
"profile is %s", _tmp5_, _tmp8_, _tmp11_, _tmp14_, _tmp17_);
	_tmp19_ = primary;
	_tmp20_ = rygel_media_resource_get_width (_tmp19_);
	_tmp21_ = _tmp20_;
	if (_tmp21_ > 720) {
		_tmp18_ = TRUE;
	} else {
		RygelMediaResource* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		_tmp22_ = primary;
		_tmp23_ = rygel_media_resource_get_height (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp18_ = _tmp24_ > 480;
	}
	if (!_tmp18_) {
		_g_object_unref0 (primary);
		_g_object_unref0 (resources);
		return;
	}
	right_one = NULL;
	{
		GeeList* _resource_list = NULL;
		GeeList* _tmp25_;
		GeeList* _tmp26_;
		gint _resource_size = 0;
		GeeList* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		gint _resource_index = 0;
		_tmp25_ = resources;
		_tmp26_ = _g_object_ref0 (_tmp25_);
		_resource_list = _tmp26_;
		_tmp27_ = _resource_list;
		_tmp28_ = gee_collection_get_size ((GeeCollection*) _tmp27_);
		_tmp29_ = _tmp28_;
		_resource_size = _tmp29_;
		_resource_index = -1;
		while (TRUE) {
			RygelMediaResource* resource = NULL;
			GeeList* _tmp30_;
			gpointer _tmp31_;
			RygelMediaResource* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			_resource_index = _resource_index + 1;
			if (!(_resource_index < _resource_size)) {
				break;
			}
			_tmp30_ = _resource_list;
			_tmp31_ = gee_list_get (_tmp30_, _resource_index);
			resource = (RygelMediaResource*) _tmp31_;
			_tmp32_ = resource;
			_tmp33_ = rygel_media_resource_get_dlna_profile (_tmp32_);
			_tmp34_ = _tmp33_;
			if (g_strcmp0 (_tmp34_, "MPEG_TS_SD_EU_ISO") == 0) {
				RygelMediaResource* _tmp35_;
				RygelMediaResource* _tmp36_;
				_tmp35_ = resource;
				_tmp36_ = _g_object_ref0 (_tmp35_);
				_g_object_unref0 (right_one);
				right_one = _tmp36_;
				_g_object_unref0 (resource);
				break;
			}
			_g_object_unref0 (resource);
		}
		_g_object_unref0 (_resource_list);
	}
	_tmp37_ = right_one;
	if (_tmp37_ != NULL) {
		GeeList* _tmp38_;
		RygelMediaResource* _tmp39_;
		_tmp38_ = resources;
		_tmp39_ = right_one;
		gee_list_set (_tmp38_, 0, _tmp39_);
	}
	_g_object_unref0 (right_one);
	_g_object_unref0 (primary);
	_g_object_unref0 (resources);
}

static void
rygel_xbm_c4_xbox_hacks_class_init (RygelXBMC4XBoxHacksClass * klass,
                                    gpointer klass_data)
{
	rygel_xbm_c4_xbox_hacks_parent_class = g_type_class_peek_parent (klass);
	((RygelClientHacksClass *) klass)->apply = (void (*) (RygelClientHacks*, RygelMediaObject*)) rygel_xbm_c4_xbox_hacks_real_apply;
}

static void
rygel_xbm_c4_xbox_hacks_instance_init (RygelXBMC4XBoxHacks * self,
                                       gpointer klass)
{
}

GType
rygel_xbm_c4_xbox_hacks_get_type (void)
{
	static volatile gsize rygel_xbm_c4_xbox_hacks_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_xbm_c4_xbox_hacks_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelXBMC4XBoxHacksClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_xbm_c4_xbox_hacks_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelXBMC4XBoxHacks), 0, (GInstanceInitFunc) rygel_xbm_c4_xbox_hacks_instance_init, NULL };
		GType rygel_xbm_c4_xbox_hacks_type_id;
		rygel_xbm_c4_xbox_hacks_type_id = g_type_register_static (RYGEL_TYPE_XBMC_HACKS, "RygelXBMC4XBoxHacks", &g_define_type_info, 0);
		g_once_init_leave (&rygel_xbm_c4_xbox_hacks_type_id__volatile, rygel_xbm_c4_xbox_hacks_type_id);
	}
	return rygel_xbm_c4_xbox_hacks_type_id__volatile;
}

